/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package anthill.factory;

import java.io.Serializable;

/**
 *  Class used to maintain information about constructor arguments
 *  and configuration parameters
 */
final class ArgInfo implements Serializable
{
  
  /** Argument name */
  String name;
  
  /** Argument value */
  Object value;

  /** Initializes the ArgInfo object with the provided data */
  ArgInfo(Object value)
  {
	this.value = value;
  }

  /** Initializes the ArgInfo object with the provided data */
  ArgInfo(String name, Object value)
  {
	this.name = name;
	this.value = value;
  }
	
} // END ArgInfo


