/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package anthill.types;

import anthill.Resource;

/**
 *  An <CODE>URLResource</CODE> object represents an URL that can be stored,
 *  as a resource, in a URL storage. The <CODE>URLResource</CODE> interface 
 *  extends the <CODE>Resource</CODE> interfaces by adding methods to manage
 *  the stringified URL.
 *
 *  @author Alberto Montresor
 *  @version $Revision: 1.1 $
 */
public interface URLResource
extends Resource
{

  /**
   *  Returns the stringified URL for this URL resource.
   */
  public String getURL();

  /**
   *  Returns the file part of this URL.
   */
  public String getFile();

} // END URLResource

