/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package ants.messor;

import java.util.List;

import anthill.factory.Factory;
import antsim.ResourceSet;

/**
 *  A resource set for the messor ant species is empty, since for
 *  messors there is no fixed set of "resources" in the system.
 *  
 *  @author Alberto Montresor
 *  @version $Revision: 1.4 $
 */
public class MessorResourceSet
implements ResourceSet
{

  /**
   *  Creates an empty resource set. 
   *  
   *  @param factory the factory to be used to read configuration arguments
   *    and to create other configurable objects
   *  @param name the name that is associated to this instance in the
   *    configuration file
   */
  public MessorResourceSet(Factory factory, String name)
  {
  }

  /**
   *  Returns null to represent this empty set of resources.
   */
  public List getResources()
  {
    return null;
  }
  
  /**
   *  Restores the object to its initial state.
   */
  public void clear()
  {
  }
  
} // END MessorResourceSet

