/*
 * Copyright (c) 2001 The Anthill Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package antsim;

import anthill.nest.*;

/**
 *  Interface <CODE>SimulatedNest</CODE> extends <CODE>Nest</CODE> by
 *  adding methods for managing simulated nests, such as methods to
 *  obtain the ant manager associated to the nest, or to force the
 *  simulated nest to leave.
 * 
 *  @author Alberto Montresor
 *  @version $Revision: 1.2 $
 */
public interface SimulatedNest
extends Nest
{
  
  /**
   *  Returns the <CODE>Manager</CODE> object associated to this nest
   */
  public Manager getManager();
  
  
  /**
   *  Forces the nest to exit. 
   */
  void leave();
  

} // END SimulatedNest
