/* Generated by Together */

package jxtaimpl;
import net.jxta.discovery.DiscoveryService;
import net.jxta.impl.peergroup.StdPeerGroup;
import net.jxta.pipe.PipeService;
import net.jxta.protocol.PipeAdvertisement;

/**
 * This is the class implementing the AnthillGroup 
 * @author Francesco Russo (frusso@cs.unibo.it) 
 */
public class AnthillGroup extends StdPeerGroup 
{
  /**
  * This is the default constructor. No arguments are needed, all the useful properties have to be set via their own set methods
  */
  public AnthillGroup() 
  {
	super();
  }

  /**
   * This method will be invoked by the GateService instance in order to obtain a reference 
   * to the Nest. 
   */
  public Nest getNest() 
  {
	return nest;
  }

  /**
  * Method for setting the right Nest instance, invoked by the AnthillPeerWS instance
  */
  protected void setNest(Nest nest)
  { 
	this.nest = nest; 
  }

  /**
  * This method returns the PipeAdv associated with the GateService 
  */
  protected PipeAdvertisement getGsPipeAdv()
  { 
	return gsPipeAdv; 
  }

  /**
  * This method sets the PipeAdv associated with the GateService. 
  * It has to be invoked by the AnthillPeerWS instance
  */
  protected void setGsPipeAdv(PipeAdvertisement gsPipeAdv)
  { 
	this.gsPipeAdv = gsPipeAdv; 
  }
  
  /**
  * This method returns the PipeAdv associated with the DownloadService 
  */
  protected PipeAdvertisement getDsPipeAdv()
  { 
	return dsPipeAdv; 
  }

  /**
  * This method sets the PipeAdv associated with the DownloadService. 
  * It has to be invoked by the AnthillPeerWS instance
  */
  protected void setDsPipeAdv(PipeAdvertisement dsPipeAdv)
  { 
	this.dsPipeAdv = dsPipeAdv; 
  }

  /**
  * Returns the NetPeerGroup's PipeService
  */
  public PipeService getNetPipeService()
  { 
	return netPipeService; 
  }

  /**
  * Sets the NetPeerGroup's PipeService. It has to be invoked by the AnthillPeerWS instance 
  */
  protected void setNetPipeService(PipeService netPipeService)
  { 
	this.netPipeService = netPipeService;
  }

  /**
  * Returns the NetPeerGroup's DiscoveryService
  */
  public DiscoveryService getNetDiscoveryService()
  { 
	return netDiscoveryService;
  }

  /**
  * Sets the NetPeerGroup's DiscoveryService. It has to be invoked by the AnthillPeerWS instance
  */
  protected void setNetDiscoveryService(DiscoveryService netDiscoveryService)
  { 
	this.netDiscoveryService = netDiscoveryService;
  }
  
  /**
  * A reference to the local Nest
  */
  private Nest nest;

  /**
   * This property has a getter and a setter used by the GateService instance in order to obtain the pipeAdvertisement it needs.
   */
  private PipeAdvertisement gsPipeAdv;

  /**
   * This property is the NetPeerGroup's PipeService. We have a setter and getter for this property too. 
   */
  private PipeService netPipeService;
  
  /**
   * This property has a getter and a setter used by the DownloadService instance in order to obtain the pipeAdvertisement it needs.
   */
  private PipeAdvertisement dsPipeAdv;

  /**
   * This property is the NetPeerGroup's DiscoveryService. We have a setter and a getter for it. 
   */
  private DiscoveryService netDiscoveryService;
  
  /**
  * Manager of the neighbourhood.
  */
  private NeighbourManager neighbourManager;
}
