/* Generated by Together */

package jxtaimpl;

import java.io.Serializable;
import java.util.*;

import anthill.Neighbour;
import anthill.util.Clearable;

/**
*  This synchronized class is used as a repository for storing information about this nest's neighbourhood.
*  This class has to be instantiated by the AnthillPeerWS, and a reference to the instance 
*  itself has to be passed to the Nest instance (see sequence diagrams for more)
*/
public class NeighbourManager implements Clearable, Serializable
{
  /**
  * Defaul constructor
  */
  public NeighbourManager() 
  {
	hTab = new Hashtable();
  }
  
  /**
  * This method cleans up the cache of neighbours managed by the 
  * NeighbourManager instance
  */
  public synchronized void clear()
  {
	hTab = new Hashtable();
  }

  /**
  * A new Neighbour instance is created using the given NestId and added to the internal
  * data structure using the NestId as key value. When adding new entries this method checks 
  * whether there is already a key of the same value or not, in order to avoid duplicates
  * 
  * @param id The ID to be added to the set of known neighbours
  */
  protected synchronized void addNeighbour(anthill.NestId id) 
  {
	if ( ! hTab.containsKey(((jxtaimpl.ids.NestId)id).toString()) )
	  {
		Neighbour neighbour = new Neighbour( id );
		hTab.put( ((jxtaimpl.ids.NestId)id).toString(), neighbour );
		System.out.println("--- NeighbourManager: add DONE!");
	  }
  }

  /**
  * This method removes the neighbour entry associated with the specified id.
  * It will return null if and only if the specified id is unknown
  *
  * @param id The ID of the Nest to be removed from the set of known neighbours
  */
  protected synchronized Object removeNeighbour(anthill.NestId id) 
  {
	if ( hTab.containsKey(((jxtaimpl.ids.NestId)id).toString()) ) 
	{  
		System.out.println("--- NeighbourManager: remove DONE!");
	    return( hTab.remove( ((jxtaimpl.ids.NestId)id).toString() ) );
	}
	System.out.println("--- NeighbourManager: remove DONE value NULL!");
	return null;
  }
  
  /**
  * Return the values contained in this set, shaped as an array of Neighbours
  */
  protected synchronized Neighbour[] toArray()
  { 
	Collection collection = hTab.values();
	Object[] temp = collection.toArray();
	Neighbour[] res = new Neighbour[temp.length];
	for (int i=0; i<temp.length; i++)
	{
	  res[i] = (Neighbour)temp[i];
	}
	return res;
  }
  
  /**
  * Return the number of elements stored 
  */
  protected synchronized int size()
  {
	return hTab.size();
  }

  private Hashtable hTab;
}
