/* Generated by Together */

package jxtaimpl;

import java.util.Hashtable;

import anthill.NestId;

/**
 * This class is meant for storing associations such as (AntId, NestId) where the NestId
 * identifies the nest this ant came from
 * @author Francesco Russo (frusso@cs.unibo.it) 
 * @stereotype implementationClass
 */
public class Trail implements anthill.storage.Trail 
{
  /**
  * Default constructor
  */
  public Trail() 
  {
    hTab = new Hashtable();
  }

  /**
  * Add a new entry. This new entry's key is the AntId
  * This method will return TRUE iff that's the first time the ant identified by
  * antId is storing information in this Trail instance
  */
  public synchronized boolean add(anthill.AntId antId, anthill.NestId srcNest) 
  {
    if (antId == null)
    {
      System.out.println("--- Trail: add ANTID is null!");
      System.exit(1);
    }
    if (srcNest == null)
    {
      System.out.println("--- Trail: add NESTID is null!");
      System.exit(1);
    }
    if ( ! hTab.containsKey(((jxtaimpl.ids.AntId)antId).getId()) ) 
    {
      hTab.put( ((jxtaimpl.ids.AntId)antId).getId(), srcNest );
      return true;
    }
    return false;
  }

  /**
  * Look for the NestId associated with the provided AntId. The entry itself is
  * going to be removed just in case the "remove" argument is true. If nothing is
  * found, null will be returned
  */
  public synchronized NestId lookup(anthill.AntId antId, boolean remove) 
  {
    NestId id = null;
  
    if ( remove )
    {
      id = (NestId) hTab.remove( ((jxtaimpl.ids.AntId)antId).getId() ); 
    }
    else
    {
      id = (NestId) hTab.get( ((jxtaimpl.ids.AntId)antId).getId() );
    }
    
    return id;
  }
  
  /**
  * Bring the initial state of this object back
  */
  public synchronized void clear()
  {
    hTab.clear();
  }
  
  /**
  * This is the hash table used for storing all the entries
  */
  private Hashtable hTab;
}
