/******************************************************
 * File: QueryResults.java
 * created 27-Jan-02 5:48:17 PM by root
 */


package jxtaimpl.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import javax.swing.*;
import javax.swing.border.Border;
import jxtaimpl.storage.AnthillResource;

import anthill.*;
import anthill.nest.*;
import anthill.storage.CapacityException;


public class QueryResults extends JFrame
			  implements ActionListener, ResponseListener
{
  private Vector resources;
  private Nest localNest;
  private JLabel searchByLabel;
  private JLabel keywordsLabel;
  private JTextField searchByText;
  private JTextField keywordsText;
  private JTextField status;
  //private JTextArea dataArea;
  private JTable dataArea;
  private JScrollPane scrollPane;
  private JButton saveButton;
  private int tot;
  
  public QueryResults(Nest nest, String element, String keys)
  {
	tot = 0;
	resources = new Vector();
	localNest = nest;
	
	setTitle("Anthill&Jxta: Query Results");
	setSize(500, 580);
	setResizable( true );
	addWindowListener( new WindowAdapter()
					  {
						public void windowClosing( WindowEvent e)
						{
				  			dispose();
						}
			 		  }
					 );
	searchByLabel = new JLabel("Search by:");
	keywordsLabel = new JLabel("Keywords:");
	searchByText = new JTextField( element );
	keywordsText = new JTextField( keys );
	searchByText.setEditable( false );
	keywordsText.setEditable( false );
	status = new JTextField("Results: please, wait...");
	status.setEditable( false );
	//dataArea = new JTextArea(20,15);
	dataArea = new JTable(20,4);
	dataArea.setValueAt( "  NAME", 0, 0);
	dataArea.setValueAt( "  TYPE", 0, 1);
	dataArea.setValueAt( "  LENGTH (bytes)", 0, 2);
	dataArea.setValueAt( "  DESCRIPTION", 0, 3);
	//dataArea.setEditable( false );
	//dataArea.setLineWrap( true );
	scrollPane = new JScrollPane( dataArea );
	saveButton = new JButton("Save");
	saveButton.addActionListener( this );
	
	JPanel panel = new JPanel();
	GridBagLayout lay = new GridBagLayout();
	Border etched = BorderFactory.createEtchedBorder();
	panel.setLayout(lay);
	panel.setBorder(etched);
	
	panel.add(searchByLabel, createConstraints(0,0,1,1,1,1));
	panel.add(keywordsLabel, createConstraints(1,0,1,1,1,1));
	panel.add(searchByText, createConstraints(0,1,1,1,1,1));
	panel.add(keywordsText, createConstraints(1,1,1,1,1,1));
	
	getContentPane().add( panel, "North" );
	
	panel = new JPanel();
	lay = new GridBagLayout();
	etched = BorderFactory.createEtchedBorder();
	panel.setLayout(lay);
	panel.setBorder(etched);
	panel.add(status, createConstraints(0,0,1,1,1,1));
	panel.add(scrollPane, createConstraints(0,1,100,100,100,100));
	getContentPane().add( panel, "Center" );
	
	panel = new JPanel();
	panel.add( saveButton );
	getContentPane().add( panel, "South" );
  }
  
  public void actionPerformed ( ActionEvent evt )
  {
  	Object src = evt.getSource();
	
	if( src == saveButton )
	{
		int row = dataArea.getSelectedRow();
	  	if ( (row == -1)||(row == 0)||(row > resources.size()) )
	  	{
	        JOptionPane.showMessageDialog( this, "Select a valid row, please.", "Anthill&Jxta: Missing Row", JOptionPane.INFORMATION_MESSAGE);
		}
	 	else
		{
			row = row-1;
			if( this.resources.elementAt(row) != null )
			{
				try
				{
		  			//((jxtaimpl.Nest)localNest).insert( (AnthillResource)this.resources.elementAt(row), ((AnthillResource)this.resources.elementAt(row)).getSpecies() );
					((jxtaimpl.Nest)localNest).downloadResource( (AnthillResource)this.resources.elementAt(row) );
					JOptionPane.showMessageDialog( this, "Resource saved!", "Anthill&Jxta: Done!", JOptionPane.INFORMATION_MESSAGE);
				}
				catch( CapacityException ce )
				{
					  JOptionPane.showMessageDialog( this, "Not enough disk space left!", "Anthill&Jxta: Not Enough Space", JOptionPane.INFORMATION_MESSAGE);
				}
			}
		}
	}
  }
  
  public void complete()
  {
  }
  
  public void returnResources( RequestId reqId, Resource[] resources )
  {
  	int j = tot+1;
	tot = tot + resources.length;
	
	for(int i=0; i<resources.length; i++)
	{
	  status.setText("Results: found "+tot+" resource(s)");
	  char[] c = new char[] {'\n'};
	  String ret = new String(c);
	  //dataArea.append( ((AnthillResource)resources[i]).getResourceName() + ret );
	  dataArea.setValueAt( ((AnthillResource)resources[i]).getResourceName(), j, 0 );
	  dataArea.setValueAt( ((AnthillResource)resources[i]).getAttribute("type"), j, 1);
	  dataArea.setValueAt( new Long( (((AnthillResource)resources[i]).getContentLength()) ), j, 2 );
	  dataArea.setValueAt( ((AnthillResource)resources[i]).getAttribute("description"), j, 3);
	  j++;
	  this.resources.addElement( resources[i] );
	}
	this.repaint();
	this.resources.trimToSize();
  }
  
  private GridBagConstraints createConstraints(int gx, int gy, int gw, int gh, int wx, int wy)
	{
	GridBagConstraints c = new GridBagConstraints();

	c.gridx = gx;
	c.gridy = gy;
	c.gridwidth = gw;
	c.gridheight = gh;
	c.weightx = wx;
	c.weighty = wy;
	 c.insets = new Insets(1,1,1,1);
	c.fill = GridBagConstraints.HORIZONTAL;
  
	return c;
	}
}
