/******************************************************
 * File: UnsharingForm.java
 * created 29-Jan-02 6:05:43 PM by frusso@cs.unibo.it
 */

package jxtaimpl.gui;

import java.awt.event.*;

import javax.swing.*;
import jxtaimpl.storage.AnthillResource;

import anthill.nest.Nest;

public class UnsharingForm extends JFrame implements ActionListener
{
  private AnthillResource[] resources;
  private JTable table;
  private JScrollPane scroll;
  private JButton unshareButton;
  private Nest localNest;
  
  public UnsharingForm(Nest nest, AnthillResource[] res)
  {
    resources = res;
    localNest = nest;
    
    setTitle("Anthill&Jxta: Unshare Local Resources");
    setSize( 500, 300 );
    setResizable( true );
    addWindowListener( new WindowAdapter()
                      {
                public void windowClosing( WindowEvent e)
                {
                  dispose();
                }
             }
            );
    table = new JTable( res.length+1, 4 );
    table.setValueAt( "  NAME", 0, 0);
    table.setValueAt( "  TYPE", 0, 1);
    table.setValueAt( "  LENGTH (bytes)", 0, 2);
    table.setValueAt( "  DESCRIPTION", 0, 3);
    for(int i=0; i<res.length; i++)
    {
      if ( res[i] != null )
      {
        table.setValueAt( res[i].getResourceName(), i+1, 0);
        table.setValueAt( res[i].getAttribute("type"), i+1, 1);
        table.setValueAt( new Long(res[i].getContentLength()), i+1, 2);
        table.setValueAt( res[i].getAttribute("description"), i+1, 3);
      }
    }
    scroll = new JScrollPane( table );
    getContentPane().add( scroll, "Center" );
    
    unshareButton = new JButton("Unshare");
    unshareButton.addActionListener( this );
    getContentPane().add( unshareButton, "South");
  }
  
  public void actionPerformed ( ActionEvent evt )
    {
    Object src = evt.getSource();
    
    if( src == unshareButton )
    {
      int row = table.getSelectedRow();
      if ( (row == -1)||(row == 0) )
      {
        JOptionPane.showMessageDialog( this, "Select one row, please.", "Anthill&Jxta: Missing Row", JOptionPane.INFORMATION_MESSAGE);
      }
      else
      {
         row = row-1;
        if( resources[row] != null )
        {
          ((jxtaimpl.Nest)localNest).unShare( resources[row] );
          resources[row] = null;
          UnsharingForm form = new UnsharingForm(localNest, resources );        
          this.dispose();
          form.show();
        }
        else
        {
          JOptionPane.showMessageDialog( this, "Select a valid entry, please", "Anthill&Jxta: Missing Data", JOptionPane.INFORMATION_MESSAGE);
        }
      }
    }
  }
}
