/******************************************************
 * File: ContentUploader.java
 * created 24-May-02 9:15:48 PM by root
 */


package techrep;

import java.io.*;
import java.net.URL;

import javax.swing.JOptionPane;
import jxtaimpl.*;
import jxtaimpl.storage.ResourceAlreadyStoredException;

import anthill.storage.CapacityException;


public class ContentUploader extends Thread
{
	private String fileName;
	private String resLocation;
	private String descr;
	private String species;
	private Nest nest; 

	public ContentUploader(String fileName, String resLocation, String descr, String species, Nest nest )
	{
		this.resLocation = resLocation;
		this.fileName = fileName;
		this.descr = descr;
		this.species = species;
		this.nest = nest;
	}
	
	public void run() 
	{
		try
		{
			URL fileUrl = new URL( resLocation );
			InputStream is = fileUrl.openStream();
			ByteArrayOutputStream os = new ByteArrayOutputStream();
			int data = is.read();
			while( data != -1 )
			{
				os.write( data );
				data = is.read();
			}
			byte[] content = os.toByteArray();
			nest.shareResource( content, fileName, "", descr, species );
			JOptionPane.showMessageDialog( null, "Done!", "Anthill&Jxta: Shared!", JOptionPane.INFORMATION_MESSAGE);
		}
		catch(IOException ioe)
		{
			JOptionPane.showMessageDialog( null, "Impossible to share "+resLocation, "Anthill&Jxta: Error", JOptionPane.ERROR_MESSAGE);
			ioe.printStackTrace();
			return;
		}
		catch( SpeciesNotFoundException snfe )
		{
			JOptionPane.showMessageDialog( null, "Wrong ant species.", "Anthill&Jxta: Wrong Data", JOptionPane.ERROR_MESSAGE);
			return;
		}
		catch( ResourceAlreadyStoredException rase )
		{
			//JOptionPane.showMessageDialog( null, "The resource seems to be already in the storage, sorry.", "Anthill&Jxta: Error", JOptionPane.ERROR_MESSAGE);
		    //return;
		}
		catch( CapacityException ce )
		{
			JOptionPane.showMessageDialog( null, "Not enough space available, sorry.", "Anthill&Jxta: Error", JOptionPane.ERROR_MESSAGE);
			return;
		}
	}
}
